/*
Use source code downloads, example commands,
and any other techniques at your own risk.
No warranty is provided.
*/
package org.jboss.soa.esb.samples.quickstart.helloworld.test;
import java.util.Properties;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;


public class Sender {

	String url_;
	String name_;
	 QueueConnection conn;
	 QueueSession session;
	 Queue queue;
	    

	public Sender(String url, String name) throws JMSException, NamingException {

		url_ = url;
		name_ = name;

    		this.initializeSender();

    	}

	private void initializeSender() throws JMSException, NamingException {


        Properties properties = new Properties();
        properties.put(Context.INITIAL_CONTEXT_FACTORY,
				"org.jboss.naming.remote.client.InitialContextFactory");
		//properties1.put(Context.URL_PKG_PREFIXES,				"org.jboss.naming:org.jnp.interfaces");
        properties.put(Context.PROVIDER_URL, "remote://localhost:1099");
		
        properties.put(Context.SECURITY_PRINCIPAL, "testuser");
        properties.put(Context.SECURITY_CREDENTIALS, "testpass");

        System.out.println("testhere");
		Context iniCtx = new InitialContext(properties);

    	Object tmp = iniCtx.lookup("jms/RemoteConnectionFactory");
    	QueueConnectionFactory qcf = (QueueConnectionFactory) tmp;
    	conn = qcf.createQueueConnection("testuser","testpass");
    	queue = (Queue) iniCtx.lookup("jms/queue/RegQueue");
    	session = conn.createQueueSession(false, QueueSession.AUTO_ACKNOWLEDGE);
    	conn.start();
    	System.out.println("Connection Started");
	}

	 public void send(String text) throws JMSException, NamingException {
	        QueueSender send = session.createSender(queue);        
	        ObjectMessage oMsg = session.createObjectMessage(text);
	        send.send(oMsg);        
	        send.close();
	 }


	public void disconnect() throws JMSException {
		if(conn != null) {
			conn.stop();
		}

		if(session != null) {
			session.close();
		}

		if(conn != null) {
			conn.close();
		}
	}

	public String getTopicName() {
		return name_;
	}

	public String getTopicURL() {
		return url_;
	}

	public static void main(String args[]) throws Exception {

		System.out.println("Starting JMS Sender");

        	Sender sender = new Sender("127.0.0.1:1099", "queue/MyQueueESB");

        	System.out.println("Sending a order");

        	sender.send("<Order orderId=\"1\" orderDate=\"Wed Nov 15 13:45:28 EST 2006\" statusCode=\"0\" netAmount=\"59.97\" totalAmount=\"64.92\" tax=\"4.95\"><Customer userName=\"user1\" firstName=\"Harry\" lastName=\"Fletcher\" state=\"SD\"/>	<OrderLines>		<OrderLine position=\"1\" quantity=\"1\">			<Product productId=\"364\" title=\"The 40-Year-Old Virgin \" price=\"29.98\"/>		</OrderLine>		<OrderLine position=\"2\" quantity=\"1\">			<Product productId=\"299\" title=\"Pulp Fiction\" price=\"29.99\"/>		</OrderLine>	</OrderLines></Order>");
        	//sender.send("<?xml version=\"1.0\" encoding=\"UTF-8\"?>        	<Order orderId=\"1182\" orderDate=\"Sat Oct 06 13:41:16 EDT 2007\" status=\"P\" totalPrice=\"188.29\" username=\"j2ee\" shipToFirstName=\"Sally\" shipToLastName=\"Smith\" shipState=\"CA\">        	  <LineItems>        	    <LineItem lineNumber=\"1\" quantity=\"2\">        	      <Item itemId=\"EST-1\" listPrice=\"16.5\"  name=\"Hamster Complete\"/>        	    </LineItem>        	    <LineItem lineNumber=\"2\" quantity=\"1\">        	      <Item itemId=\"EST-27\" listPrice=\"155.29\" name=\"Super Puppy Breakfast\" />        	    </LineItem>        	  </LineItems>        	</Order>        	");
        	//sender.send("Mr.Deeds 2002");
        	//sender.send("Eight Crazy Nights 2002");
       	 	//sender.send("Anger Management 2003");

        	sender.disconnect();

       	 	//System.out.println("JMS Sender Complete - list sent");

     }

}
